#===============================================================================
#. Name  : Variveis aleatrias - propriedades da esperana matemtica (E)
#.         e da varincia (V)
#. Author: Jos Cludio Faria
# Date  : 19/11/2021 13:53:57
# Aim   : Entendimento das propriedades (E e V) das variveis aleatrias
# Mail  : <<<joseclaudio.faria@gmail.com>>>
#===============================================================================

#... Obs: K  uma constante

#. Esperana matemtica (E)
#.. E(K) = K
(K <- 5)
mean(rep(K,
         K)) == K

#.. E(Y  K) = E(Y)  K
(Y <- -10:10)

#... E(Y + K) = E(Y) + K
round(mean(Y + K),
      5) ==
round(mean(Y) + K,
            5)

#... E(Y - K) = E(Y) - K
round(mean(Y - K),
      5) ==
round(mean(Y) - K,
      5)

#.. E(KY) = K * E(Y)
round(mean(K*Y),
      5) ==
round(K * mean(Y),
      5)

#.. E(Y  Z) = E(Y)  E(Z)
(Z <- Y^2)

#... E(Y + Z) = E(Y) + E(Z)
round(mean(Y + Z),
      5) ==
round(mean(Y) + mean(Z),
      5)

#... E(Y - Z) = E(Y) - E(Z)
round(mean(Y - Z),
      5) ==
round(mean(Y) - mean(Z),
      5)

#.. Se Y e Z so independentes: E(YZ) = E(Y) * E(Z)
# Visualizao grfica
plot(Z ~ Y,
     pch=20)
abline(v=mean(Y),
       col=2)
abline(h=mean(Z),
       col=4)

# Cov = O  indicao de independncia?
cov(Y, Z)

round(mean(Y*Z),
      5) ==
round(mean(Y) * mean(Z),
      5)


#. Varincia (V)
#.. V(K) = 0
var(rep(K,
        K)) == 0

#.. V(Y  K) = V(Y)
#... V(Y + K) = V(Y)
round(var(Y + K),
      5) ==
round(var(Y),
      5)

#... V(Y - K) = V(Y)
round(var(Y - K),
      5) ==
round(var(Y),
      5)

#.. V(KY) = K^2.V(Y)
round(var(K*Y),
      5) ==
round(K^2 * var(Y),
      5)

#... Se Y e Z so independentes
# Cov = O  indicao de independncia?
cov(Y, Z)

#.. V(Y  Z) = V(Y) + V(Z)
#... V(Y + Z) = V(Y) + V(Z)
round(var(Y + Z),
      5) ==
round(var(Y) + var(Z),
      5)

#... V(Y - Z) = V(Y) + V(Z)
round(var(Y - Z),
      5) ==
round(var(Y) + var(Z),
      5)

#... Caso contrrio (no independentes)
#.. V(Y  Z) = V(Y) + V(Z)  2*Cov(Y, Z)
(Y <- rnorm(20))
(Z <- 2*Y)
cov(Y, Z) # Associao no nula
cor(Y, Z) # Associao perfeita e positiva

#... V(Y + Z) = V(Y) + V(Z) + 2*Cov(Y, Z)
round(var(Y + Z),
      2) ==
round(var(Y) + var(Z) + 2*cov(Y, Z),
      2)

#... V(Y - Z) = V(Y) + V(Z) - 2*Cov(Y, Z)
round(var(Y - Z),
      5) ==
round(var(Y) + var(Z) - 2*cov(Y, Z),
      5)
